package com.ktg.iscs.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ktg.common.core.domain.entity.SysDictData;
import com.ktg.iscs.domain.IsSop;
import com.ktg.iscs.domain.dto.sop.AddSopDTO;
import com.ktg.iscs.domain.dto.sop.PageSopDTO;
import com.ktg.iscs.domain.vo.sop.SopDetailVO;
import com.ktg.iscs.domain.vo.sop.SopPageVO;

import java.util.List;

/**
 * SOP信息Service接口
 *
 * @author cgj
 * @date 2024-10-18
 */
public interface IIsSopService extends IService<IsSop>
{
    /**
     * 查询SOP信息
     *
     * @param sopId SOP信息主键
     * @return SOP信息
     */
    SopDetailVO selectIsSopBySopId(Long sopId);

    /**
     * 查询SOP信息列表
     *
     * @param isSop SOP信息
     * @return SOP信息集合
     */
    List<IsSop> selectIsSopList(IsSop isSop);

    /**
     * 新增SOP信息
     *
     * @param dto SOP信息
     * @return 结果
     */
    Boolean insertIsSop(AddSopDTO dto);

    /**
     * 修改SOP信息
     *
     * @param dto SOP信息
     * @return 结果
     */
    Boolean updateIsSop(AddSopDTO dto);

    /**
     * 批量删除SOP信息
     *
     * @param sopIds 需要删除的SOP信息主键集合
     * @return 结果
     */
    Boolean deleteIsSopBySopIds(String sopIds);

    /**
     * 删除SOP信息信息
     *
     * @param sopId SOP信息主键
     * @return 结果
     */
    int deleteIsSopBySopId(Long sopId);

    /**
     * sop分页查询
     * @param page
     * @param dto
     * @return
     */
    Page<SopPageVO> getIsSopPage(Page<IsSop> page, PageSopDTO dto);

    Boolean updateIsSopIndex(IsSop isSop);

    List<SysDictData> selectSopTypeByMachineryId(Long machineryId);
}
